/*
 * Harbor API
 * These APIs provide services for manipulating Harbor project.
 *
 * OpenAPI spec version: 2.0
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.4.19
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/RobotPermission'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('./RobotPermission'));
  } else {
    // Browser globals (root is window)
    if (!root.HarborApi) {
      root.HarborApi = {};
    }
    root.HarborApi.Robot = factory(root.HarborApi.ApiClient, root.HarborApi.RobotPermission);
  }
}(this, function(ApiClient, RobotPermission) {
  'use strict';

  /**
   * The Robot model module.
   * @module model/Robot
   * @version 2.0
   */

  /**
   * Constructs a new <code>Robot</code>.
   * @alias module:model/Robot
   * @class
   */
  var exports = function() {
  };

  /**
   * Constructs a <code>Robot</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/Robot} obj Optional instance to populate.
   * @return {module:model/Robot} The populated <code>Robot</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();
      if (data.hasOwnProperty('id'))
        obj.id = ApiClient.convertToType(data['id'], 'Number');
      if (data.hasOwnProperty('name'))
        obj.name = ApiClient.convertToType(data['name'], 'String');
      if (data.hasOwnProperty('description'))
        obj.description = ApiClient.convertToType(data['description'], 'String');
      if (data.hasOwnProperty('secret'))
        obj.secret = ApiClient.convertToType(data['secret'], 'String');
      if (data.hasOwnProperty('level'))
        obj.level = ApiClient.convertToType(data['level'], 'String');
      if (data.hasOwnProperty('duration'))
        obj.duration = ApiClient.convertToType(data['duration'], 'Number');
      if (data.hasOwnProperty('editable'))
        obj.editable = ApiClient.convertToType(data['editable'], 'Boolean');
      if (data.hasOwnProperty('disable'))
        obj.disable = ApiClient.convertToType(data['disable'], 'Boolean');
      if (data.hasOwnProperty('expires_at'))
        obj.expiresAt = ApiClient.convertToType(data['expires_at'], 'Number');
      if (data.hasOwnProperty('permissions'))
        obj.permissions = ApiClient.convertToType(data['permissions'], [RobotPermission]);
      if (data.hasOwnProperty('creation_time'))
        obj.creationTime = ApiClient.convertToType(data['creation_time'], 'Date');
      if (data.hasOwnProperty('update_time'))
        obj.updateTime = ApiClient.convertToType(data['update_time'], 'Date');
    }
    return obj;
  }

  /**
   * The ID of the robot
   * @member {Number} id
   */
  exports.prototype.id = undefined;

  /**
   * The name of the tag
   * @member {String} name
   */
  exports.prototype.name = undefined;

  /**
   * The description of the robot
   * @member {String} description
   */
  exports.prototype.description = undefined;

  /**
   * The secret of the robot
   * @member {String} secret
   */
  exports.prototype.secret = undefined;

  /**
   * The level of the robot, project or system
   * @member {String} level
   */
  exports.prototype.level = undefined;

  /**
   * The duration of the robot in days
   * @member {Number} duration
   */
  exports.prototype.duration = undefined;

  /**
   * The editable status of the robot
   * @member {Boolean} editable
   */
  exports.prototype.editable = undefined;

  /**
   * The disable status of the robot
   * @member {Boolean} disable
   */
  exports.prototype.disable = undefined;

  /**
   * The expiration data of the robot
   * @member {Number} expiresAt
   */
  exports.prototype.expiresAt = undefined;

  /**
   * @member {Array.<module:model/RobotPermission>} permissions
   */
  exports.prototype.permissions = undefined;

  /**
   * The creation time of the robot.
   * @member {Date} creationTime
   */
  exports.prototype.creationTime = undefined;

  /**
   * The update time of the robot.
   * @member {Date} updateTime
   */
  exports.prototype.updateTime = undefined;


  return exports;

}));
